#if defined(HAVE_CONFIG_H)
#include "../hdrfiles/config.h"
#endif

#include "../hdrfiles/includes.h"

/*--------------------------------------------------------*/
/* Talker-related include files                           */ 
/*--------------------------------------------------------*/
#include "../hdrfiles/osdefs.h"
/*
#include "../hdrfiles/authuser.h"
#include "../hdrfiles/text.h"
*/
#include "../hdrfiles/constants.h"
#include "../hdrfiles/protos.h"

extern int checked;
extern int dobackups;
extern int NUM_AREAS;
extern int MESS_LIFE;
extern char mess[ARR_SIZE+25];
extern char t_mess[ARR_SIZE+25];

/*** check to see if messages are out of date ***/
void check_mess(int startup)
{  
int b,day,day2;
int normcount=0;
int wizcount=0;
char line[ARR_SIZE+31],datestr[30],timestr[7],daystr[11],daystr2[3];
char boardfile[FILE_NAME_LEN],tempfile[FILE_NAME_LEN];
time_t tm;
FILE *bfp,*tfp;

timestr[0]=0;

time(&tm);
strcpy(datestr,ctime(&tm));
midcpy(datestr,timestr,11,15);
midcpy(datestr,daystr,8,9);
day=atoi(daystr);   
    
/* see if its time to check (midnight) */
if (startup==1) goto SKIP;
else if (startup==2) goto WLOG;

if (checked)
  {
   checked = 0;
   return;
  }
else if ((!strcmp(timestr,"00:01") || !strcmp(timestr,"00:00")) && !checked)
  {
   checked = 1;
  }
else return; 

SKIP:
if (!startup) {  
        write_area(-1,"");
	write_area(-1,"SYSTEM: Midnight system check taking place, please wait...");
	write_log(SYSTEMLOG,YESTIME,"SYSTEM: Midnight system check in progress..\n"); 
	}
    
/* cycle through files */
            
strcpy(tempfile,get_temp_file());

for(b=0;b<NUM_AREAS+1;++b) {
        if (b == NUM_AREAS)
          sprintf(boardfile,"%s/wizmess",MESSDIR);
         else
          sprintf(boardfile,"%s/board%d",MESSDIR,b);

        if (!(bfp=fopen(boardfile,"r"))) continue;
        if (!(tfp=fopen(tempfile,"w"))) {
               if (startup==1) {
                write_log(ERRLOG,YESTIME,"Couldn't open tempfile(w) %s in check_mess! %s\n",tempfile,get_error());
                perror("\nSYSTEM: Cant open tempfile(w) in check_mess");
                FCLOSE(bfp);
#if defined(WINDOWS)
WSACleanup();
#endif
                exit(0);
                }
                else {
                write_log(ERRLOG,YESTIME,"Couldn't open tempfile(w) %s in check_mess! %s\n",tempfile,get_error());
                FCLOSE(bfp);
                checked = 0;
                return;
                }
           }
        
        /* go through board and write valid messages to temp file */
        fgets(line,ARR_SIZE+30,bfp);
        while(!feof(bfp)) {
                midcpy(line,daystr2,5,6);
                day2=atoi(daystr2);
                if (day2>day) day2 -= 30;  /* if mess from prev. month */
                if (day2>=day-MESS_LIFE)
                 fputs(line,tfp);
                else {
                 if (b == NUM_AREAS) wizcount++;
                 else normcount++;
                 
                 astr[b].mess_num--;
                 }
                fgets(line,1050,bfp);
                }   
        FCLOSE(bfp);
        FCLOSE(tfp);
        remove(boardfile);
        
        /* rename temp file back to board file */
        if (rename(tempfile,boardfile) == -1)
         astr[b].mess_num=0;
        
        remove(tempfile);

        /* If changed boards are left with no messages, remove them */
        if (!file_count_lines(boardfile)) remove(boardfile);
                
        } /* end of for */
                
  /* Reset user auto-forward limits to nill */
  if (startup==1)
    printf("Resetting auto-forward limits and checking user abbreviations..\n");
   reset_userfors(startup);
                 
  /* Remove all temp files from the junk directory */
  if (startup==1)
    printf("Removing temp files..\n");
   remove_junk(startup);
                 
  if (!startup) {   
  /* Auto expire users if set */
  auto_expire();
  /* Expire email verifications from today */
  check_verify(-1,1);
  /* We'll do daily backups here */
  if (dobackups) backup_logs(-1);
  /* We'll do cleaning of old backups here */
  trim_backups(-1,TRIM_BACKUPS);
  }     
        
WLOG:
  /* Append the day's user activity to the activity file */
  if ((startup==2) || (!startup)) {
    if (checked) write_meter(1);
    else write_meter(0);
   }
    
  /* Reset logins per hour numbers */
  b=0;           
  for (b=0;b<24;++b) {
     logstat[b].logins = 0;
     }
   
        system_stats.logins_today       = 0;
        system_stats.new_users_today    = 0;
  
if (!startup) { 
        write_area(-1,"");
        write_area(-1,"SYSTEM: Check completed. Carry on!");
        write_log(SYSTEMLOG,YESTIME,"SYSTEM: Midnight check completed.\n");
	write_log(SYSTEMLOG,YESTIME,"SYSTEM: %d old messages deleted from boards\n",normcount);
	write_log(SYSTEMLOG,YESTIME,"SYSTEM: %d old messages deleted from wiz board\n",wizcount);
   }    
if (startup==1) {
	write_log(SYSTEMLOG,YESTIME,"SYSTEM: %d old messages deleted from boards\n",normcount);
        write_log(SYSTEMLOG,YESTIME,"SYSTEM: %d old messages deleted from wiz board\n",wizcount);
   }

return;
} 


/* Count number of users in our user storage directory */
void check_total_users(int mode)
{
char small_buffer[FILE_NAME_LEN];
char filerid[FILE_NAME_LEN];
char z_mess[ARR_SIZE];
struct dirent *dp;
DIR *dirp;

 sprintf(z_mess,"%s",USERDIR);
 strncpy(filerid,z_mess,FILE_NAME_LEN);

 dirp=opendir((char *)filerid);

 if (dirp == NULL)
   {
    if (mode==1) {
      write_log(ERRLOG,YESTIME,"TOTUSERS: Can't open directory \"%s\" for check_total_users! %s\n",filerid,get_error());
      sprintf(z_mess,"\nSYSTEM: Can't open directory \"%s\" for check_total_users! %s",filerid,get_error());
      perror(z_mess);
#if defined(WINDOWS)
WSACleanup();
#endif
      exit(0); 
      }
    else {
      write_log(ERRLOG,YESTIME,"TOTUSERS: Can't open directory \"%s\" for check_total_users! %s\n",filerid,get_error());
      return;
     }
   }

system_stats.tot_users = 0;

 while ((dp = readdir(dirp)) != NULL)
   {

    sprintf(small_buffer,"%s",dp->d_name);
        if (small_buffer[0] == '.')
         continue;
        else
         system_stats.tot_users++;
    
   }
      
 (void) closedir(dirp);
}

/*--------------------------------------*/
/* Now we check who we have to alert    */
/* of our login.                        */
/*--------------------------------------*/
void check_alert(int user, int mode)
{
int u=0;
int i=0;
char check[50];

for (u=0;u<MAX_USERS;++u) {

          if (ustr[u].area!= -1 && u !=user) {
 
                        for (i=0; i<MAX_ALERT; ++i) {
                        strcpy(check,ustr[u].friends[i]);
                        strtolower(check);
                        if (!strcmp(ustr[user].name,check))
                           {
                            if (mode==0) {
                              if (!user_wants_message(u,BEEPS))
                               sprintf(mess,"^HR.ALERT!^ %s has logged on.",ustr[user].say_name);
                              else
                               sprintf(mess,"^HR.ALERT!^ %s has logged on.\07\07",ustr[user].say_name);
                              write_str(u,mess);
                           break;
                           } /* end of if mode 0 */
			else if ((mode==1) && (ustr[u].area!=ustr[user].area)) {
                              if (!user_wants_message(u,BEEPS))
				sprintf(mess,"^HM.ALERT!^ %s has come back from being ^HYAFK^",ustr[user].say_name);
                              else
				sprintf(mess,"^HM.ALERT!^ %s has come back from being ^HYAFK^\07\07",ustr[user].say_name);
                              write_str(u,mess);
                           break;
                           } /* end of if mode 1 */
                         } /* end of strcmp if */
                        } /* end of sub-for */
                  i=0; continue;  
              }    /* end of if */
   }   /* end of for */
 
}


/*------------------------*/
/* Check for gagged user  */
/*------------------------*/
int check_gag(int user, int user2, int mode)
{
int b=0;
char check[50];

      for (b=0; b<MAX_GAG; ++b) {
        strcpy(check,ustr[user2].gagged[b]);
        strtolower(check);
        if (!strcmp(ustr[user].name,check)) {
           if (!mode)
            write_str(user,IS_GAGGED);

           check[0]=0;
           return 0;
          }
        check[0]=0;
        }

return 1;  
}


/*----------------------------------------*/
/* Check for gagged user that isnt online */
/*----------------------------------------*/
int check_gag2(int user, char *name)
{
int b=0;
char check[50];

if (!read_user(name)) return 2;

      for (b=0; b<MAX_GAG; ++b) {
        strcpy(check,t_ustr.gagged[b]);
        strtolower(check);
        if (!strcmp(ustr[user].name,check)) {
           write_str(user,IS_GAGGED);
           check[0]=0;
           return 0;   
          }
        check[0]=0;
        }
         
return 1;
}


/*** Check for new mail ***/
void check_mail(int user) 
{
struct stat stbuf;
char filename[FILE_NAME_LEN], datestr[24];
    
sprintf(t_mess,"%s/%s",MAILDIR,ustr[user].name);
strncpy(filename,t_mess,FILE_NAME_LEN);
if (stat(filename, &stbuf) == -1)
  {
   return;             
  }

if (ustr[user].new_mail)
  {
   write_str(user," ");
      sprintf(t_mess,MAIL_NEW,ustr[user].mail_num,ustr[user].mail_num == 1 ? "" : "s");
   write_str(user,t_mess);
   write_str(user," ");
  }
   
strcpy(datestr,ctime(&stbuf.st_mtime));
   
sprintf(mess,MAIL_ACCESS,datestr);
write_str(user,mess);

if (ustr[user].new_mail &&
    ((ustr[user].autor==1) || (ustr[user].autor==3)) ) {
   sprintf(mess,"%i",ustr[user].mail_num);
   read_mail(user,mess);
   }

}


